xine-lib: xine-lib-1.2.13/src/demuxers/demux_fli.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions | Variables
demux_fli.c File Reference
`#include <stdio.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`
`#include "bswap.h"`

## Data Structures
struct | demux_fli_t

## Macros
#define | FLI_HEADER_SIZE 128
#define | FLI_HEADER_SIZE_MC 12 /* header size for Magic Carpet game FLIs */
#define | FLI_FILE_MAGIC_1 0xAF11
#define | FLI_FILE_MAGIC_2 0xAF12
#define | FLI_FILE_MAGIC_3 0xAF13 /* for internal use only */
#define | FLI_CHUNK_MAGIC_1 0xF1FA
#define | FLI_CHUNK_MAGIC_2 0xF5FA
#define | FLI_MC_PTS_INC 6000 /* pts increment for Magic Carpet game FLIs */

## Functions
static int | open_fli_file (demux_fli_t *this)
static int | demux_fli_send_chunk (demux_plugin_t *this_gen)
static void | demux_fli_send_headers (demux_plugin_t *this_gen)
static int | demux_fli_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_fli_get_status (demux_plugin_t *this_gen)
static int | demux_fli_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_fli_get_capabilities (demux_plugin_t *this_gen)
static int | demux_fli_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
static void * | init_plugin (xine_t *xine, const void *data)

## Variables
static const demuxer_info_t | demux_info_fli
const plugin_info_t xine_plugin_info[] | EXPORTED

## Macro Definition Documentation

## ◆ FLI_CHUNK_MAGIC_1

#define FLI_CHUNK_MAGIC_1 0xF1FA

Referenced by demux_fli_send_chunk(), and open_fli_file().

## ◆ FLI_CHUNK_MAGIC_2

#define FLI_CHUNK_MAGIC_2 0xF5FA

Referenced by demux_fli_send_chunk().

## ◆ FLI_FILE_MAGIC_1

#define FLI_FILE_MAGIC_1 0xAF11

Referenced by open_fli_file().

## ◆ FLI_FILE_MAGIC_2

#define FLI_FILE_MAGIC_2 0xAF12

Referenced by open_fli_file().

## ◆ FLI_FILE_MAGIC_3

#define FLI_FILE_MAGIC_3 0xAF13 /* for internal use only */

Referenced by open_fli_file().

## ◆ FLI_HEADER_SIZE

#define FLI_HEADER_SIZE 128

Referenced by open_fli_file().

## ◆ FLI_HEADER_SIZE_MC

#define FLI_HEADER_SIZE_MC 12 /* header size for Magic Carpet game FLIs */

Referenced by open_fli_file().

## ◆ FLI_MC_PTS_INC

#define FLI_MC_PTS_INC 6000 /* pts increment for Magic Carpet game FLIs */

Referenced by open_fli_file().

## Function Documentation

## ◆ demux_fli_get_capabilities()

static uint32_t demux_fli_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_fli_get_optional_data()

static int demux_fli_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_fli_get_status()

static int demux_fli_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_fli_get_stream_length()

static int demux_fli_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_fli_seek()

static int demux_fli_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_control_newpts(), DEMUX_OK, and input().

Referenced by open_plugin().

## ◆ demux_fli_send_chunk()

static int demux_fli_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References _X_LE_16, _X_LE_32, BUF_FLAG_FRAME_END, BUF_VIDEO_FLI, buf_element_s::content, buf_element_s::decoder_flags, DEMUX_FINISHED, buf_element_s::extra_info, FLI_CHUNK_MAGIC_1, FLI_CHUNK_MAGIC_2, buf_element_s::free_buffer, input(), extra_info_s::input_normpos, extra_info_s::input_time, buf_element_s::max_size, NULL, buf_element_s::pts, buf_element_s::size, and buf_element_s::type.

Referenced by open_plugin().

## ◆ demux_fli_send_headers()

static void demux_fli_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), BUF_FLAG_FRAME_END, BUF_FLAG_FRAMERATE, BUF_FLAG_HEADER, BUF_FLAG_STDHEADER, BUF_VIDEO_FLI, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, DEMUX_OK, buf_element_s::size, buf_element_s::type, XINE_STREAM_INFO_FRAME_DURATION, XINE_STREAM_INFO_HAS_AUDIO, XINE_STREAM_INFO_HAS_VIDEO, XINE_STREAM_INFO_VIDEO_HEIGHT, and XINE_STREAM_INFO_VIDEO_WIDTH.

Referenced by open_plugin().

## ◆ init_plugin()

static void * init_plugin | ( | xine_t * | xine,
|  | const void * | data )
| static

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ open_fli_file()

static int open_fli_file | ( | demux_fli_t * | this | ) |
| static

References _x_demux_read_header(), _X_LE_16, _X_LE_32, FLI_CHUNK_MAGIC_1, FLI_FILE_MAGIC_1, FLI_FILE_MAGIC_2, FLI_FILE_MAGIC_3, FLI_HEADER_SIZE, FLI_HEADER_SIZE_MC, FLI_MC_PTS_INC, input(), and INPUT_IS_SEEKABLE.

Referenced by open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_fli_get_capabilities(), demux_fli_get_optional_data(), demux_fli_get_status(), demux_fli_get_stream_length(), demux_fli_seek(), demux_fli_send_chunk(), demux_fli_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, open_fli_file(), and input_plugin_s::seek.

Referenced by init_plugin().

## Variable Documentation

## ◆ demux_info_fli

const demuxer_info_t demux_info_fli
| static

Initial value:
= {
.priority = 10,
}

## ◆ EXPORTED

const plugin_info_t xine_plugin_info [] EXPORTED

Initial value:
= {
{ PLUGIN_DEMUX, 27, "fli", XINE_VERSION_CODE, &demux_info_fli, init_plugin },
{ PLUGIN_NONE, 0, NULL, 0, NULL, NULL }
}
init_plugin
static void * init_plugin(xine_t *xine, const void *data)
Definition demux_fli.c:348
demux_info_fli
static const demuxer_info_t demux_info_fli
Definition demux_fli.c:368
XINE_VERSION_CODE
#define XINE_VERSION_CODE
Definition xine_internal.h:57
NULL
NULL
Definition xine_plugin.c:78
PLUGIN_DEMUX
#define PLUGIN_DEMUX
Definition xine_plugin.h:31
PLUGIN_NONE
#define PLUGIN_NONE
Definition xine_plugin.h:29